module Control(
    Control
  , acc
  , setAcc
  , brake
  , setBrake
  , angle
  , setAngle
  , initialControl
  , mainControl
  ) where

import Control.Monad.ST
import Types 
import Geometry (Angle)

-- Control elements: acceleration, braking, turning, 
-- plus some state elements if we want...
data Control = Control { acc   :: !Double
		       , brake :: !Bool
		       , angle :: !Angle
		       , count :: !Int
		       }

setAcc :: Double-> Control-> Control
setAcc a c = c{acc= a}

setBrake :: Bool-> Control-> Control
setBrake b c = c{brake= b}

setAngle :: Angle-> Control-> Control
setAngle a c = c{angle= a}

-- 
-- Central control function: given car state and user control, produce
--  safe car control.
--

mainControl :: Control-> Car-> Sensor-> Control
mainControl ctrl car s =  ctrl{count= count ctrl+1}

initialControl :: Control
initialControl =  Control {acc= 0, angle=0, brake= False, count= 0}
                 
